.386
.model flat, stdcall
option casemap:none

include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc
include	\masm32\include\user32.inc

include	PEmem.inc                             ; function prototypes for PEmem.lib
include	invoke.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib

includelib  lib\PEmem.lib

EXTERN      pDLL:BYTE                             ; pointer to consfunc.dll
                                                  ; linked  to the main executable

.data

DLLfunc     db 'StdOut',0 ; StdOut function from consfunc.dll
message     db 'StdOut function - DLL from memory test',0
errmessage1 db 'DLL loading failure',0
errmessage2 db 'GetProcAddr cannot find the address',13,10
            db 'of the requested function',0
caption     db 'Error',0

.data?

hVirtModule dd ?                                  ; handle to the "virtual" module consfunc.dll

.code

start:

    invoke  LoadEXEfromMem,ADDR pDLL
    or      eax,eax                               ; check the value of entry point
    jnz     @f                                    ; returned by eax
    invoke  MessageBox,0,ADDR errmessage1,ADDR caption,MB_ICONERROR
    jmp     finish2
                                                  
@@:

    mov     hVirtModule,edx
    invoke  GetProcAddr,edx,ADDR DLLfunc          ; GetProcAddr gets the address of StdOut
                                                  ; from our "virtual" consfunc.dll
    or      eax,eax
    jnz     @f
    invoke  MessageBox,0,ADDR errmessage2,ADDR caption,MB_ICONERROR
    jmp     finish1

@@:
    
   _invoke  eax,ADDR message                      ; macro simulating invoke to call
                                                  ; the function StdOut pointed by eax
   
finish1:   

    invoke  VirtualFree,hVirtModule,0,MEM_RELEASE ; Release the memory allocated
                                                  ; for consfunc.dll
finish2:

    invoke  ExitProcess,0

END start     